=== unittests/Analysis/FlowSensitive/CMakeLists.txt ===
add_clang_unittest(ClangAnalysisFlowSensitiveTests
  ArenaTest.cpp
  ASTOpsTest.cpp
  CFGMatchSwitchTest.cpp
  CachedConstAccessorsLatticeTest.cpp
  ChromiumCheckModelTest.cpp
  DataflowAnalysisContextTest.cpp
  DataflowEnvironmentTest.cpp
  DebugSupportTest.cpp
  DeterminismTest.cpp
  LoggerTest.cpp
  MapLatticeTest.cpp
  MatchSwitchTest.cpp
  MultiVarConstantPropagationTest.cpp
  RecordOpsTest.cpp
  SignAnalysisTest.cpp
  SimplifyConstraintsTest.cpp
  SingleVarConstantPropagationTest.cpp
  SmartPointerAccessorCachingTest.cpp
  TestingSupport.cpp
  TestingSupportTest.cpp
  TransferBranchTest.cpp
  TransferTest.cpp
  TypeErasedDataflowAnalysisTest.cpp
  UncheckedOptionalAccessModelTest.cpp
  ValueTest.cpp
  WatchedLiteralsSolverTest.cpp
  CLANG_LIBS
  clangAST
  clangASTMatchers
  clangAnalysis
  clangAnalysisFlowSensitive
  clangAnalysisFlowSensitiveModels
  clangBasic
  clangFrontend
  clangLex
  clangSerialization
  clangTooling
  LINK_LIBS
  clangTesting
  LLVMTestingAnnotations
  LLVMTestingSupport
  LLVM_COMPONENTS
  FrontendOpenMP
  Support
  )
